package com.poto.timeservice;

import android.content.Intent;
import android.os.Bundle;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import androidx.appcompat.app.AppCompatActivity;
import androidx.recyclerview.widget.LinearLayoutManager;
import androidx.recyclerview.widget.RecyclerView;
import butterknife.BindView;
import butterknife.ButterKnife;
import com.poto.timeservice.Member.PoCreateMemberController;
import com.poto.timeservice.Model.PoMemberModel;

public class MainActivity extends AppCompatActivity implements View.OnClickListener {
    // params
    @BindView(R.id.searchBar)
    EditText searchBar;
    @BindView(R.id.tableView)
    RecyclerView tableView;
    @BindView(R.id.createBtn)
    Button createBtn;
    @BindView(R.id.memberBtn)
    Button memberBtn;

    // 数据
    private PotMainAdapter adapter;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        ButterKnife.bind(this);
        setupSubViews();
        configSubViews();
    }

    private void setupSubViews() {
        adapter = new PotMainAdapter(this);

        LinearLayoutManager layout = new LinearLayoutManager(this);
        tableView.setLayoutManager(layout);
        tableView.setAdapter(adapter);
    }

    private void configSubViews() {
        createBtn.setOnClickListener(this);
        memberBtn.setOnClickListener(this);
        /*输入监控*/
        searchBar.addTextChangedListener(new TextWatcher() {
            @Override
            public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {
            }

            @Override
            public void afterTextChanged(Editable editable) {
                String text = editable.toString();
                filterMemberWithText(text);
            }
        });
    }

    @Override
    public void onClick(View view) {
        switch (view.getId()) {
            case R.id.createBtn: {
                createBtnClickAction();
            }
            break;
            case R.id.memberBtn: {
                memberBtnClickAction();
            }
            break;
        }
    }

    /*点击事件*/
    void createBtnClickAction() {
        /*新建会员界面*/
        Intent controller = new Intent(MainActivity.this, PoCreateMemberController.class);
        startActivity(controller);
    }

    void memberBtnClickAction() {
        adapter.removeObject(3);
    }

    /*辅助*/
    /*
     * 筛选 列表
     * */
    void filterMemberWithText(String text) {

    }
}
