package com.poto.timeservice.Member;

import android.content.Context;
import android.text.Editable;
import android.text.TextWatcher;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.EditText;
import android.widget.TextView;
import androidx.recyclerview.widget.RecyclerView;
import com.poto.timeservice.Model.PoMemberEditRowModel;
import com.poto.timeservice.Model.PoMemberModel;
import com.poto.timeservice.PoCommon;
import com.poto.timeservice.R;
import java.util.ArrayList;

/*会员 adapter*/
public class PoCreateMemberAdapter extends RecyclerView.Adapter<PoCreateMemberAdapter.PotViewHolder>  {
    private final LayoutInflater layout;
    private final Context theContext;
    /*标记编辑模式*/
    private Boolean editType;
    /*当前录入的用户资料*/
    private PoMemberModel theMember;
    /*编辑字段的key值*/
    private ArrayList<PoMemberEditRowModel> dataSource;

    public PoCreateMemberAdapter(Context context, PoMemberModel editMemmber) {
        layout = LayoutInflater.from(context);
        theContext = context;

        dataSource = new ArrayList<>();
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowInput, "姓名", "请输入姓名", "name"));
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowDate, "生日", "请选择生日", "birth"));
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowInput, "电话", "请输入电话", "tel"));
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowProvCA, "省份", "请选择省份", "prov"));
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowProvCA, "城市", "请选择城市", "city"));
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowProvCA, "区域", "请选择区域", "area"));
        dataSource.add(PoMemberEditRowModel.create(PoCommon.PoMemberEditRowKind.PoMemberEditRowMutInput, "地址", "请输入地址", "address"));

        editType = (editMemmber != null);
        if (!editType) {
            theMember = new PoMemberModel();
        } else {
            theMember = editMemmber;
        }
    }

    @Override
    public PoCreateMemberAdapter.PotViewHolder onCreateViewHolder(ViewGroup parent, int viewType) {
        return new PoCreateMemberAdapter.PotViewHolder(layout.inflate(R.layout.activity_po_create_member_cell, parent, false));
    }

    @Override
    public void onBindViewHolder(final PoCreateMemberAdapter.PotViewHolder holder, int pos) {
        PoMemberEditRowModel model = dataSource.get(pos);
        holder.markLab.setText(model.getMark());
        holder.inputField.setHint(model.getPlaceholder());
        holder.inputField.setCursorVisible(false);

        /*点击|输入区分*/
        switch (model.getKind()) {
            case PoMemberEditRowDate:
            case PoMemberEditRowProvCA:
            case PoMemberEditRowStrList: {
            }
                break;
            case PoMemberEditRowInput:
            case PoMemberEditRowMutInput: {
                holder.inputField.addTextChangedListener(new TextWatcher() {
                    @Override
                    public void beforeTextChanged(CharSequence charSequence, int i, int i1, int i2) {

                    }

                    @Override
                    public void onTextChanged(CharSequence charSequence, int i, int i1, int i2) {

                    }

                    @Override
                    public void afterTextChanged(Editable editable) {

                    }
                });
            }
                break;
        }
    }

    @Override
    public int getItemCount() {
        return dataSource == null ? 0 : dataSource.size();
    }

    /*数据操作*/
    public void addObject(PoMemberEditRowModel model) {
        dataSource.add(model);
        notifyItemInserted(dataSource.size() - 1);
    }

    public void removeObject(int pos) {
        dataSource.remove(pos);
        notifyItemRemoved(pos);
    }

    /*view*/
    static class PotViewHolder extends RecyclerView.ViewHolder {
        /*标记*/
        TextView markLab;
        /*输入*/
        EditText inputField;

        PotViewHolder(View itemView) {
            super(itemView);
            markLab = itemView.findViewById(R.id.markLab);
            inputField = itemView.findViewById(R.id.inputField);
        }
    }
}
